from amino import List, Map

special_codes = Map({
    b'\x80\xffX': 'c-@',
    b'\x80kb': 'bs',
    9: 'tab',
    b'\x80kB': 's-tab',
    10: 'c-j',
    11: 'c-k',
    12: 'fe',
    13: 'cr',
    27: 'esc',
    32: 'space',
    60: 'lt',
    92: 'bslash',
    124: 'bar',
    b'\x0b': 'c-k',
    b'\x80kD': 'del',
    b'\x9B': 'csi',
    b'\x80\xfdP': 'xcsi',
    b'\x80ku': 'up',
    b'\x80kd': 'down',
    b'\x80kl': 'left',
    b'\x80kr': 'right',
    b'\x80\xfd': 's-up',
    b'\x80\xfd': 's-down',
    b'\x80#4': 's-left',
    b'\x80%i': 's-right',
    b'\x80\xfdT': 'c-left',
    b'\x80\xfdU': 'c-right',
    b'\x80k1': 'f1',
    b'\x80k2': 'f2',
    b'\x80k3': 'f3',
    b'\x80k4': 'f4',
    b'\x80k5': 'f5',
    b'\x80k6': 'f6',
    b'\x80k7': 'f7',
    b'\x80k8': 'f8',
    b'\x80k9': 'f9',
    b'\x80k;': 'f10',
    b'\x80F1': 'f11',
    b'\x80F2': 'f12',
    b'\x80\xfd\x06': 's-f1',
    b'\x80\xfd\x07': 's-f2',
    b'\x80\xfd\x08': 's-f3',
    b'\x80\xfd\x09': 's-f4',
    b'\x80\xfd\x0A': 's-f5',
    b'\x80\xfd\x0B': 's-f6',
    b'\x80\xfd\x0C': 's-f7',
    b'\x80\xfd\x0D': 's-f8',
    b'\x80\xfd\x0E': 's-f9',
    b'\x80\xfd\x0F': 's-f10',
    b'\x80\xfd\x10': 's-f11',
    b'\x80\xfd\x11': 's-f12',
    b'\x80%1': 'help',
    b'\x80&8': 'undo',
    b'\x80kI': 'insert',
    b'\x80kh': 'home',
    b'\x80@7': 'end',
    b'\x80kP': 'pageup',
    b'\x80kN': 'pagedown',
    b'\x80K1': 'khome',
    b'\x80K4': 'kend',
    b'\x80K3': 'kpageup',
    b'\x80K5': 'kpagedown',
    b'\x80K6': 'kplus',
    b'\x80K7': 'kminus',
    b'\x80K9': 'kmultiply',
    b'\x80K8': 'kdivide',
    b'\x80KA': 'kenter',
    b'\x80KB': 'kpoint',
    b'\x80KC': 'k0',
    b'\x80KD': 'k1',
    b'\x80KE': 'k2',
    b'\x80KF': 'k3',
    b'\x80KG': 'k4',
    b'\x80KH': 'k5',
    b'\x80KI': 'k6',
    b'\x80KJ': 'k7',
    b'\x80KK': 'k8',
    b'\x80KL': 'k9',
})


modifier_codes = List(
    (2, 'shift'),
    (4, 'control'),
    (8, 'alt'),
    (16, 'meta'),
    (32, 'mouse_double'),
    (64, 'mouse_triple'),
    (96, 'mouse_quadruple'),
    (128, 'command'),
)

__all__ = ('special_codes', 'modifier_codes',)
